Imports System.IO
Imports System.Xml

Namespace SeaVan
	Public Class CrossingXmlParser

		#Region "Fields"
		Private Shared BC_CROSSING_COUNT As Short = 4
		#End Region

		#Region "ParseXmlUs (OLD)"
        'Friend Shared Sub ParseXmlUs(ByVal result As Stream)
        '    'Dim xdoc As New XDocument
        '    Dim xdoc As XDocument = XDocument.Load(result)

        '    ' Get the date/time the WSDOT data was last updated (already in PST/PDT).
        '    Dim guidElement As XElement = xdoc.Descendants("guid").First
        '    If guidElement IsNot Nothing Then
        '        Dim guidString As String = guidElement.Value
        '        ' "Fri+Mar+30+14%3a15%3a22+PDT+2012"

        '        guidString = guidString.Replace("+"c, " "c)
        '        guidString = guidString.Replace("%3a", ":")
        '        ' "Fri Mar 30 14:15:22 PDT 2012"

        '        Dim dateParts() As String = guidString.Split(" "c)
        '        Dim updateString As String = String.Format("{0}, {1} {2} {3} {4}", dateParts(0), dateParts(2), dateParts(1), dateParts(5), dateParts(3))
        '        ' "Fri, 30 Mar 2012 14:15:22"

        '        Dim [date] As Date
        '        If Date.TryParse(updateString, [date]) Then
        '            App.Crossings.LastUpdateUs = "last update (sea) - " & [date]
        '            Debug.WriteLine(String.Format("webClientUs_OpenReadCompleted: {0} [parse ok]", App.Crossings.LastUpdateUs))
        '        Else
        '            App.Crossings.LastUpdateUs = "last update (sea) - " & Date.Now
        '            Debug.WriteLine(String.Format("webClientUs_OpenReadCompleted: {0} [defaulted]", App.Crossings.LastUpdateUs))
        '        End If
        '    Else
        '        App.Crossings.LastUpdateUs = "last update (sea) - " & Date.Now
        '        Debug.WriteLine(String.Format("webClientUs_OpenReadCompleted: [guid element not found]"))
        '    End If

        '    ' Extract the CDATA section as a string, and reduce it to an array of crossing|wait-time pairs.
        '    Dim node As XNode = xdoc.DescendantNodes.Single(Function(el) el.NodeType = XmlNodeType.CDATA)
        '    Dim content As String = node.Parent.Value
        '    GetWaitTimesUs(content)
        'End Sub
		#End Region

		#Region "ParseXmlUs"
		'   <title>Canadian Border Crossings - Fri Jun 15 11:15:00 PDT 2012</title> 

		Friend Shared Sub ParseXmlUs(ByVal result As Stream)
			Dim xdoc As XDocument = XDocument.Load(result)

			' Get the date/time the WSDOT data was last updated (already in PST/PDT).
			Dim itemElement As XElement = xdoc.Descendants("item").First
			Dim titleElement As XElement = itemElement.Descendants("title").First
			If titleElement IsNot Nothing Then
				Dim titleString As String = titleElement.Value
				' "Canadian Border Crossings - Fri Jun 15 11:15:00 PDT 2012"

				titleString = titleString.Replace("Canadian Border Crossings - ", "")
				' "Fri Jun 15 11:15:00 PDT 2012"

				Dim dateParts() As String = titleString.Split(" "c)
				Dim updateString As String = String.Format("{0}, {1} {2} {3} {4}", dateParts(0), dateParts(2), dateParts(1), dateParts(5), dateParts(3))
				' "Fri, 15 Jun 2012 11:15:00"

				Dim [date] As Date
				If Date.TryParse(updateString, [date]) Then
					App.Crossings.LastUpdateUs = "last update (sea) - " & [date]
					Debug.WriteLine(String.Format("webClientUs_OpenReadCompleted: {0} [parse ok]", App.Crossings.LastUpdateUs))
				Else
					App.Crossings.LastUpdateUs = "last update (sea) - " & Date.Now
					Debug.WriteLine(String.Format("webClientUs_OpenReadCompleted: {0} [defaulted]", App.Crossings.LastUpdateUs))
				End If
			Else
				App.Crossings.LastUpdateUs = "last update (sea) - " & Date.Now
				Debug.WriteLine(String.Format("webClientUs_OpenReadCompleted: [title element not found]"))
			End If

			' Extract the CDATA section as a string, and reduce it to an array of crossing|wait-time pairs.
			Dim node As XNode = xdoc.DescendantNodes.Single(Function(el) el.NodeType = XmlNodeType.CDATA)
			Dim content As String = node.Parent.Value
			GetWaitTimesUs(content)
		End Sub
		#End Region

		#Region "GetWaitTimesUs"
		Private Shared Sub GetWaitTimesUs(ByVal content As String)
			content = content.ToLower
			content = content.Replace("<br/>", "")
			content = content.Replace("<strong>station name:</strong>", ",")
			content = content.Replace("<strong>wait time:</strong>", "|")

			Dim crossingData() As String = content.Split(","c)
			Dim usCrossings As New Dictionary(Of String, String)
			For i  = 1 To crossingData.Length - 1
				Dim crossingParts() As String = crossingData(i).Split("|"c)
				usCrossings.Add(crossingParts(0), crossingParts(1))
			Next i

			For Each crossing As BorderCrossing In App.Crossings.Crossings
				Select Case crossing.PortID
					Case "300401"
						crossing.PassengerDelayTimeUs = GetValueOrDefault(usCrossings, "sr543")
						crossing.NexusDelayTimeUs = GetValueOrDefault(usCrossings, "sr543nexus")
						crossing.CommercialDelayTimeUs = GetValueOrDefault(usCrossings, "sr543trucks")
						crossing.FastDelayTimeUs = GetValueOrDefault(usCrossings, "sr543trucksfast")
						Debug.WriteLine(String.Format("GetWaitTimesUsa: 300401: std={0},nex={1},com={2},fst={3}", crossing.PassengerDelayTimeUs, crossing.NexusDelayTimeUs, crossing.CommercialDelayTimeUs, crossing.FastDelayTimeUs))
					Case "300402"
						crossing.PassengerDelayTimeUs = GetValueOrDefault(usCrossings, "i5")
						crossing.NexusDelayTimeUs = GetValueOrDefault(usCrossings, "i5nexus")
						Debug.WriteLine(String.Format("GetWaitTimesUsa: 300402: std={0},nex={1}", crossing.PassengerDelayTimeUs, crossing.NexusDelayTimeUs))
					Case "300901"
						crossing.PassengerDelayTimeUs = GetValueOrDefault(usCrossings, "sr9")
						Debug.WriteLine(String.Format("GetWaitTimesUsa: 300901: std={0}", crossing.PassengerDelayTimeUs))
					Case "302301"
						crossing.PassengerDelayTimeUs = GetValueOrDefault(usCrossings, "sr539")
						Debug.WriteLine(String.Format("GetWaitTimesUsa: 302301: std={0}", crossing.PassengerDelayTimeUs))
				End Select
			Next crossing
		End Sub

		Private Shared Function GetValueOrDefault(ByVal d As Dictionary(Of String, String), ByVal key As String) As String
            Dim s As String = String.Empty
			d.TryGetValue(key, s)
			If s Is Nothing Then
				s = "no data"
			End If
			Return s
		End Function
		#End Region

		#Region "ParseXmlCa"
		Friend Shared Sub ParseXmlCa(ByVal result As Stream)
            'XDocument xdoc = new XDocument()
			Dim xdoc As XDocument = XDocument.Load(result)
			Dim waitTimes = xdoc.Elements("border_wait_time")

			' Get the date/time the CBP data was last updated, and convert from EST/EDT to PST/PDT.
			Dim d As String = String.Empty
			Dim t As String = String.Empty
			Dim dateElement As XElement = waitTimes.Elements("last_updated_date").First
			If dateElement IsNot Nothing Then
				d = dateElement.Value
			End If
			Dim timeElement As XElement = waitTimes.Elements("last_updated_time").First
			If timeElement IsNot Nothing Then
				t = timeElement.Value
			End If
			If (Not String.IsNullOrEmpty(d)) AndAlso (Not String.IsNullOrEmpty(t)) Then
				Dim [date] As Date
				If Date.TryParse(d & " " & t & "-4:00", [date]) Then
					App.Crossings.LastUpdateCa = "last update (van) - " & [date]
					Debug.WriteLine(String.Format("webClientCa_OpenReadCompleted: {0} [parse ok]", App.Crossings.LastUpdateCa))
				Else
					App.Crossings.LastUpdateCa = "last update (van) - " & Date.Now
					Debug.WriteLine(String.Format("webClientCa_OpenReadCompleted: {0} [defaulted]", App.Crossings.LastUpdateCa))
				End If
			Else
				App.Crossings.LastUpdateCa = "last update (van) - " & Date.Now
				Debug.WriteLine(String.Format("webClientCa_OpenReadCompleted: {0} [date/time not found]", App.Crossings.LastUpdateCa))
			End If

			' Out of the 72 ports of entry, add the 4 BC ports we care about to the list.
			Dim count As Short = 0
			For Each port As XElement In waitTimes.Elements("port")
				Dim portNumber As String = port.Element("port_number").Value
				Dim crossing As BorderCrossing = App.Crossings(portNumber)
				If crossing IsNot Nothing Then
					GetWaitTimesCa(port, crossing)
                    count += CShort(1)
					If count > BC_CROSSING_COUNT Then
						Exit For
					End If
				End If
			Next port
		End Sub
		#End Region

		#Region "GetWaitTimesCa"
		Private Shared Sub GetWaitTimesCa(ByVal port As XElement, ByVal crossing As BorderCrossing)
			Dim passenger As XElement = port.Element("passenger_vehicle_lanes")
			If passenger IsNot Nothing Then
				Dim passengerStandard As XElement = passenger.Element("standard_lanes")
				If passengerStandard IsNot Nothing Then
					crossing.PassengerDelayTimeCa = GetLaneDataCa(passengerStandard)
				Else
					crossing.PassengerDelayTimeCa = "no data"
				End If

				Dim passengerNexus As XElement = passenger.Element("NEXUS_SENTRI_lanes")
				If passengerNexus IsNot Nothing Then
					crossing.NexusDelayTimeCa = GetLaneDataCa(passengerNexus)
				Else
					crossing.NexusDelayTimeCa = "no data"
				End If

				Dim passengerReady As XElement = passenger.Element("ready_lanes")
				If passengerReady IsNot Nothing Then
					crossing.ReadyDelayTimeCa = GetLaneDataCa(passengerReady)
				Else
					crossing.ReadyDelayTimeCa = "no data"
				End If
			Else
				crossing.PassengerDelayTimeCa = "no data"
				crossing.NexusDelayTimeCa = "no data"
				crossing.ReadyDelayTimeCa = "no data"
			End If
			Debug.WriteLine(String.Format("GetWaitTimesCanada: std={0},nex={1},rdy={2}", crossing.PassengerDelayTimeCa, crossing.NexusDelayTimeCa, crossing.ReadyDelayTimeCa))

			Dim commercial As XElement = port.Element("commercial_vehicle_lanes")
			If commercial IsNot Nothing Then
				Dim commercialStandard As XElement = commercial.Element("standard_lanes")
				If commercialStandard IsNot Nothing Then
					crossing.CommercialDelayTimeCa = GetLaneDataCa(commercialStandard)
				Else
					crossing.CommercialDelayTimeCa = "no data"
				End If

				Dim commercialFast As XElement = commercial.Element("FAST_lanes")
				If commercialFast IsNot Nothing Then
					crossing.FastDelayTimeCa = GetLaneDataCa(commercialFast)
				Else
					crossing.FastDelayTimeCa = "no data"
				End If
			Else
				crossing.CommercialDelayTimeCa = "no data"
				crossing.FastDelayTimeCa = "no data"
			End If
			Debug.WriteLine(String.Format("GetWaitTimesCanada: com={0},fst={1}", crossing.CommercialDelayTimeCa, crossing.FastDelayTimeCa))
		End Sub
		#End Region

		#Region "GetLaneDataCa"
		Private Shared Function GetLaneDataCa(ByVal laneElement As XElement) As String
			Dim waitTime As String = "no data"
			Dim statusElement As XElement = laneElement.Element("operational_status")
			If statusElement IsNot Nothing Then
				Dim status As String = statusElement.Value.Trim.ToLower
				If status = "delay" Then
					Dim time As XElement = laneElement.Element("delay_minutes")
					If time IsNot Nothing Then
						waitTime = time.Value.Replace("min", "").Trim
					Else
						waitTime = "delay"
					End If
				ElseIf status = "no delay" Then
					waitTime = "0"
				ElseIf status = "n/a" Then
					waitTime = "-"
				ElseIf status = "lanes closed" Then
					waitTime = "closed"
				ElseIf status = "update pending" Then
					waitTime = "updating"
				Else
					waitTime = status
				End If
			End If
			Return waitTime
		End Function
		#End Region

	End Class
End Namespace
