Imports System.ComponentModel
Imports System.Threading
Imports System.Device.Location

Namespace SeaVan
	Public Class BorderCrossing
		Implements INotifyPropertyChanged

		#Region "INotifyPropertyChanged"
		Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

		Private Sub NotifyPropertyChanged(ByVal propertyName As String)
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
		End Sub
		#End Region

		#Region "per-crossing ID and Name"
        Private _portID As String
        Public Property PortID As String
            Get
                Return _portID
            End Get
            Set(ByVal value As String)
                If value <> _portID Then
                    _portID = value
                    NotifyPropertyChanged("PortID")
                End If
            End Set
        End Property

        Private _portName As String
        Public Property PortName As String
            Get
                Return _portName
            End Get
            Set(ByVal value As String)
                If _portName <> value Then
                    _portName = value
                    NotifyPropertyChanged("PortName")
                End If
            End Set
        End Property
		#End Region

		#Region "per-lane delay times canada"
        Private _passengerDelayTimeCa As String
        Public Property PassengerDelayTimeCa As String
            Get
                Return _passengerDelayTimeCa
            End Get
            Set(ByVal value As String)
                If _passengerDelayTimeCa <> value Then
                    _passengerDelayTimeCa = value
                    NotifyPropertyChanged("PassengerDelayTimeCa")
                End If
            End Set
        End Property

        Private _nexusDelayTimeCa As String
        Public Property NexusDelayTimeCa As String
            Get
                Return _nexusDelayTimeCa
            End Get
            Set(ByVal value As String)
                If value <> _nexusDelayTimeCa Then
                    _nexusDelayTimeCa = value
                    NotifyPropertyChanged("NexusDelayTimeCa")
                End If
            End Set
        End Property

        Private _readyDelayTimeCa As String
        Public Property ReadyDelayTimeCa As String
            Get
                Return _readyDelayTimeCa
            End Get
            Set(ByVal value As String)
                If _readyDelayTimeCa <> value Then
                    _readyDelayTimeCa = value
                    NotifyPropertyChanged("ReadyDelayTimeCa")
                End If
            End Set
        End Property

        Private _commercialDelayTimeCa As String
        Public Property CommercialDelayTimeCa As String
            Get
                Return _commercialDelayTimeCa
            End Get
            Set(ByVal value As String)
                If _commercialDelayTimeCa <> value Then
                    _commercialDelayTimeCa = value
                    NotifyPropertyChanged("CommercialDelayTimeCa")
                End If
            End Set
        End Property

        Private _fastDelayTimeCa As String
        Public Property FastDelayTimeCa As String
            Get
                Return _fastDelayTimeCa
            End Get
            Set(ByVal value As String)
                If _fastDelayTimeCa <> value Then
                    _fastDelayTimeCa = value
                    NotifyPropertyChanged("FastDelayTimeCa")
                End If
            End Set
        End Property
		#End Region

		#Region "per-lane delay times usa"
        Private _passengerDelayTimeUs As String
        Public Property PassengerDelayTimeUs As String
            Get
                Return _passengerDelayTimeUs
            End Get
            Set(ByVal value As String)
                If _passengerDelayTimeUs <> value Then
                    _passengerDelayTimeUs = value
                    NotifyPropertyChanged("PassengerDelayTimeUs")
                End If
            End Set
        End Property

        Private _nexusDelayTimeUs As String
        Public Property NexusDelayTimeUs As String
            Get
                Return _nexusDelayTimeUs
            End Get
            Set(ByVal value As String)
                If value <> _nexusDelayTimeUs Then
                    _nexusDelayTimeUs = value
                    NotifyPropertyChanged("NexusDelayTimeUs")
                End If
            End Set
        End Property

        Private _readyDelayTimeUs As String
        Public Property ReadyDelayTimeUs As String
            Get
                Return _readyDelayTimeUs
            End Get
            Set(ByVal value As String)
                If _readyDelayTimeUs <> value Then
                    _readyDelayTimeUs = value
                    NotifyPropertyChanged("ReadyDelayTimeUs")
                End If
            End Set
        End Property

        Private _commercialDelayTimeUs As String
        Public Property CommercialDelayTimeUs As String
            Get
                Return _commercialDelayTimeUs
            End Get
            Set(ByVal value As String)
                If _commercialDelayTimeUs <> value Then
                    _commercialDelayTimeUs = value
                    NotifyPropertyChanged("CommercialDelayTimeUs")
                End If
            End Set
        End Property

        Private _fastDelayTimeUs As String
        Public Property FastDelayTimeUs As String
            Get
                Return _fastDelayTimeUs
            End Get
            Set(ByVal value As String)
                If _fastDelayTimeUs <> value Then
                    _fastDelayTimeUs = value
                    NotifyPropertyChanged("FastDelayTimeUs")
                End If
            End Set
        End Property
		#End Region

		#Region "per-crossing coordinates"
        Private _coordinatesUs As GeoCoordinate
        Public Property CoordinatesUs As GeoCoordinate
            Get
                Return _coordinatesUs
            End Get
            Set(ByVal value As GeoCoordinate)
                If value IsNot _coordinatesUs Then
                    _coordinatesUs = value
                    NotifyPropertyChanged("CoordinatesUs")
                End If
            End Set
        End Property

        Private _coordinatesCa As GeoCoordinate
        Public Property CoordinatesCa As GeoCoordinate
            Get
                Return _coordinatesCa
            End Get
            Set(ByVal value As GeoCoordinate)
                If value IsNot _coordinatesCa Then
                    _coordinatesCa = value
                    NotifyPropertyChanged("CoordinatesCa")
                End If
            End Set
        End Property
		#End Region

	End Class
End Namespace

